searchData={"items":[{"type":"module","title":"AoC","doc":"","ref":"AoC.html"},{"type":"function","title":"AoC.run/3","doc":"","ref":"AoC.html#run/3"},{"type":"type","title":"AoC.file/0","doc":"","ref":"AoC.html#t:file/0"},{"type":"type","title":"AoC.input/0","doc":"","ref":"AoC.html#t:input/0"},{"type":"type","title":"AoC.input_path/0","doc":"","ref":"AoC.html#t:input_path/0"},{"type":"type","title":"AoC.part/0","doc":"","ref":"AoC.html#t:part/0"},{"type":"type","title":"AoC.problem/0","doc":"","ref":"AoC.html#t:problem/0"},{"type":"module","title":"AoC.API","doc":"","ref":"AoC.API.html"},{"type":"function","title":"AoC.API.cookie_path/0","doc":"","ref":"AoC.API.html#cookie_path/0"},{"type":"function","title":"AoC.API.fetch_input/2","doc":"","ref":"AoC.API.html#fetch_input/2"},{"type":"function","title":"AoC.API.headers/0","doc":"","ref":"AoC.API.html#headers/0"},{"type":"function","title":"AoC.API.user_agent/0","doc":"","ref":"AoC.API.html#user_agent/0"},{"type":"module","title":"AoC.CLI","doc":"","ref":"AoC.CLI.html"},{"type":"function","title":"AoC.CLI.color/2","doc":"Outputs `iodata` in the current shell, wrapped with formatting\ninformation, such as `[color, iodata, :default_color]`.\n\n`color` should be a `IO.ANSI.format/2` compatible atom.","ref":"AoC.CLI.html#color/2"},{"type":"function","title":"AoC.CLI.compile/0","doc":"","ref":"AoC.CLI.html#compile/0"},{"type":"function","title":"AoC.CLI.custom_defaults/0","doc":"","ref":"AoC.CLI.html#custom_defaults/0"},{"type":"function","title":"AoC.CLI.debug/1","doc":"Outputs `iodata` in the current shell, formatted with cyan color.","ref":"AoC.CLI.html#debug/1"},{"type":"function","title":"AoC.CLI.default_opt/1","doc":"Returns a default value for the `--year` or `--day` CLI options.\n\nThe current year or day based on today's date will be returned unless a forced\ndefault value has been set using `mix aoc.set`.","ref":"AoC.CLI.html#default_opt/1"},{"type":"function","title":"AoC.CLI.defaults_file/0","doc":"","ref":"AoC.CLI.html#defaults_file/0"},{"type":"function","title":"AoC.CLI.errmsg/1","doc":"","ref":"AoC.CLI.html#errmsg/1"},{"type":"function","title":"AoC.CLI.error/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with bright\nred color.","ref":"AoC.CLI.html#error/1"},{"type":"function","title":"AoC.CLI.format_usage/2","doc":"Returns a standard \"usage\" documentation block describing the different\noptions of the given command.","ref":"AoC.CLI.html#format_usage/2"},{"type":"function","title":"Options - AoC.CLI.format_usage/2","doc":"* `:format` - If `:moduledoc`, the formatted usage will be compatible for\n  embedding in a `@moduledoc` attribute. Any other value will generate a\n  simple terminal styled text. Defaults to `:cli`.","ref":"AoC.CLI.html#format_usage/2-options"},{"type":"function","title":"AoC.CLI.halt/1","doc":"Stops the execution of the Erlang runtime, with a given return code.\n\nIf not provided, the return code will be `0`.","ref":"AoC.CLI.html#halt/1"},{"type":"function","title":"AoC.CLI.halt_error/2","doc":"Combines `error/1` then `halt/1`. Halts the Erlang runtime with a `1`\nreturn code by default.","ref":"AoC.CLI.html#halt_error/2"},{"type":"function","title":"AoC.CLI.halt_success/1","doc":"Combines `success/1` then `halt/1`. Halts the Erlang runtime with a `0`\nreturn code.","ref":"AoC.CLI.html#halt_success/1"},{"type":"function","title":"AoC.CLI.init_env/0","doc":"","ref":"AoC.CLI.html#init_env/0"},{"type":"function","title":"AoC.CLI.parse/2","doc":"Accepts the command line arguments and the definition of a command\n(options, arguments, and metadata) and returns a parse result with values\nextracted from the command line arguments.","ref":"AoC.CLI.html#parse/2"},{"type":"function","title":"Defining options - AoC.CLI.parse/2","doc":"Options definitions is a `Keyword` whose keys are the option name, and\nvalues are the options parameters. Note that keys with underscores like\n`some_thing` define options in kebab case like `--some-thing`.\n\nThe following parameters are available:\n\n- `:type` - Can be either `:boolean`, `:integer` or `:string`. The default\n  value is `:string`.\n- `:short` - Defines the shortcut for the option, for instance `-p`\n  instead of `--port`.\n- `:default` - Defines the default value if the corresponding option is\n  not defined in `argv`.See \"Default values\" below.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command.\n\nNote that the `:help` option is always defined and cannot be overridden.","ref":"AoC.CLI.html#parse/2-defining-options"},{"type":"function","title":"Default values - AoC.CLI.parse/2","doc":"Default values can be omitted, in that case, the option will not be\npresent at all if not provided in the command line.\n\nWhen defined, a default value can be:\n\n* A raw value, that is anything that is not a function. This value will be\n  used as the default value.\n* A function of arity zero. This function will be called when the option\n  is not provided in the command line and the result value will be used as\n  the default value. For instance `fn -> 123 end` or `&default_age/0`.\n* A function of arity one. This function will be called with the option\n  key as its argument. For instance, passing `&default_opt/1` as the\n  `:default` for an option definition allow to define the following\n  function:\n\n      defp default_opt(:port), do: 4000\n      defp default_opt(:scheme), do: \"http\"","ref":"AoC.CLI.html#parse/2-default-values"},{"type":"function","title":"Options examples - AoC.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(--who joe), [options: [who: [type: :string]]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--who joe), [options: [who: []]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--port 4000), [options: [port: [type: :integer]]])\n    iex> result.options.port\n    4000\n\n    iex> {:ok, result} = parse(~w(-p 4000), [options: [port: [type: :integer, short: :p]]])\n    iex> result.options.port\n    4000\n\n    iex> parse(~w(--port nope), [options: [port: [type: :integer]]])\n    {:error, {:invalid, [{\"--port\", \"nope\"}]}}\n\n    iex> {:ok, result} = parse([], [options: [lang: [default: \"elixir\"]]])\n    iex> result.options.lang\n    \"elixir\"\n\n    iex> {:ok, result} = parse([], [options: [lang: []]])\n    iex> Map.has_key?(result.options, :lang)\n    false\n\n    iex> {:ok, result} = parse([], options: [])\n    iex> result.options.help\n    false\n\n    iex> {:ok, result} = parse(~w(--help), options: [])\n    iex> result.options.help\n    true","ref":"AoC.CLI.html#parse/2-options-examples"},{"type":"function","title":"Defining arguments - AoC.CLI.parse/2","doc":"Arguments can be defined in the same way, providing a `Keyword` where the\nkeys are the argument names and the values are the parameters.","ref":"AoC.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Defining arguments - AoC.CLI.parse/2","doc":"The following parameters are available:\n\n- `:required` - A boolean marking the argument as required. **Note that\n  arguments are required by default**. Keys for optional arguments that\n  are not provided by the command line will not be defined in the results.\n- `:cast` - Accepts a fun or a `{module, function, arguments}` tuple to\n  transform the argument value when parsing. The invoked function must\n  return a result tuple: `{:ok, _} | {:error, _}`.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command. Note that this is not currently implemented for\n  arguments.","ref":"AoC.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Arguments examples - AoC.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(joe), arguments: [who: []])\n    iex> result.arguments.who\n    \"joe\"\n\n    iex> parse([], arguments: [who: []])\n    {:error, {:missing_argument, :who}}\n\n    iex> {:ok, result} = parse([], arguments: [who: [required: false]])\n    iex> result.arguments\n    %{}\n\n    iex> cast = fn string -> Date.from_iso8601(string) end\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> parse([\"not-a-date\"], arguments: [date: [cast: cast]])\n    {:error, {:argument_cast, :date, :invalid_format}}","ref":"AoC.CLI.html#parse/2-arguments-examples"},{"type":"function","title":"AoC.CLI.parse_or_halt!/2","doc":"Attempts to parse the command line arguments `argv` with the defined\ncommand.\n\nCommand options and arguments are documented in the `parse/2` function of\nthis module.\n\nIn `parse_or_halt!/2`, the successful return value will not be wrapped in\nan `:ok` tuple, but directly a map with the `:options` and `:arguments`\nkeys.\n\nIn case of a parse error, this function will output the usage block\nfollowed by a formatted error message, and halt the Erlang runtime.","ref":"AoC.CLI.html#parse_or_halt!/2"},{"type":"function","title":"AoC.CLI.part_command/2","doc":"","ref":"AoC.CLI.html#part_command/2"},{"type":"function","title":"AoC.CLI.put_shell/1","doc":"Defines the current shell to send console messages to. Accepts either\n`AoC.CLI` or `AoC.CLI.ProcessShell`.\n\nThe shell is saved to `:persistent_term`, so shell should not be changed\nrepeatedly during runtime. This method of persistence is subject to change\nand should not be relied on.","ref":"AoC.CLI.html#put_shell/1"},{"type":"function","title":"AoC.CLI.shell/0","doc":"Returns the current shell used by AoC.CLI to send output.","ref":"AoC.CLI.html#shell/0"},{"type":"function","title":"AoC.CLI.success/1","doc":"Outputs `iodata` in the current shell, formatted with green color.","ref":"AoC.CLI.html#success/1"},{"type":"function","title":"AoC.CLI.validate_options!/1","doc":"","ref":"AoC.CLI.html#validate_options!/1"},{"type":"function","title":"AoC.CLI.warn/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with yellow\ncolor.","ref":"AoC.CLI.html#warn/1"},{"type":"function","title":"AoC.CLI.write_defaults/1","doc":"","ref":"AoC.CLI.html#write_defaults/1"},{"type":"function","title":"AoC.CLI.writeln/1","doc":"Outputs `iodata` in the current shell.","ref":"AoC.CLI.html#writeln/1"},{"type":"function","title":"AoC.CLI.year_day_command/2","doc":"","ref":"AoC.CLI.html#year_day_command/2"},{"type":"module","title":"AoC.CLI.ProcessShell","doc":"An output shell implementation allowing your CLI commands to send their\noutput as messages to themselves. This is most useful for tests.\n\nThe process that will receive the messages is found by looking up the\nfirst pid in the `:\"$callers\"` key of the process dictionary, or\n`self()` if there is no caller.\n\nUse `AoC.CLI.put_shell(AoC.CLI.ProcessShell)` to enable this\nshell.","ref":"AoC.CLI.ProcessShell.html"},{"type":"function","title":"AoC.CLI.ProcessShell.message_target/0","doc":"Returns the pid of the process that will receive output messages.","ref":"AoC.CLI.ProcessShell.html#message_target/0"},{"type":"module","title":"AoC.CodeGen","doc":"","ref":"AoC.CodeGen.html"},{"type":"function","title":"AoC.CodeGen.module_template/1","doc":"","ref":"AoC.CodeGen.html#module_template/1"},{"type":"function","title":"AoC.CodeGen.pad_day/1","doc":"","ref":"AoC.CodeGen.html#pad_day/1"},{"type":"function","title":"AoC.CodeGen.test_template/1","doc":"","ref":"AoC.CodeGen.html#test_template/1"},{"type":"module","title":"AoC.ComputeCache","doc":"","ref":"AoC.ComputeCache.html"},{"type":"function","title":"AoC.ComputeCache.cached/4","doc":"","ref":"AoC.ComputeCache.html#cached/4"},{"type":"module","title":"AoC.Input","doc":"","ref":"AoC.Input.html"},{"type":"function","title":"AoC.Input.apply_stream_opt/3","doc":"","ref":"AoC.Input.html#apply_stream_opt/3"},{"type":"function","title":"AoC.Input.as_file/1","doc":"","ref":"AoC.Input.html#as_file/1"},{"type":"function","title":"AoC.Input.ensure_local/3","doc":"","ref":"AoC.Input.html#ensure_local/3"},{"type":"function","title":"AoC.Input.input_path/3","doc":"","ref":"AoC.Input.html#input_path/3"},{"type":"function","title":"AoC.Input.list_of_integers/1","doc":"","ref":"AoC.Input.html#list_of_integers/1"},{"type":"function","title":"AoC.Input.read!/1","doc":"","ref":"AoC.Input.html#read!/1"},{"type":"function","title":"AoC.Input.resolve/3","doc":"","ref":"AoC.Input.html#resolve/3"},{"type":"function","title":"AoC.Input.stream!/2","doc":"","ref":"AoC.Input.html#stream!/2"},{"type":"function","title":"AoC.Input.stream_file_lines/2","doc":"","ref":"AoC.Input.html#stream_file_lines/2"},{"type":"function","title":"AoC.Input.stream_to_integers/1","doc":"","ref":"AoC.Input.html#stream_to_integers/1"},{"type":"function","title":"AoC.Input.with_index_first/2","doc":"","ref":"AoC.Input.html#with_index_first/2"},{"type":"module","title":"AoC.Input.TestInput","doc":"","ref":"AoC.Input.TestInput.html"},{"type":"task","title":"mix aoc.create","doc":"This task will execute the following operations:\n\n* Download the input from Advent of Code website into the `priv/inputs`\n  directory.\n* Create the solution module.\n* Create a test module.\n\nExisting files will not be overwritten. It is safe to call the command again\nif you need to regenerate a deleted file.\n\nThe generated files will contain some comment blocks to help you get\naccustomed to using this library. This can be annoying after some time. You\nmay disable generating those comments by setting the appropriate configuration\noption:\n\n    config :aoc, generate_comments: false","ref":"Mix.Tasks.Aoc.Create.html"},{"type":"task","title":"Usage - mix aoc.create","doc":"```shell\nmix aoc.create [options]\n```","ref":"Mix.Tasks.Aoc.Create.html#module-usage"},{"type":"task","title":"Options - mix aoc.create","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Create.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Create.print_path/2","doc":"","ref":"Mix.Tasks.Aoc.Create.html#print_path/2"},{"type":"function","title":"Mix.Tasks.Aoc.Create.run/1","doc":"","ref":"Mix.Tasks.Aoc.Create.html#run/1"},{"type":"task","title":"mix aoc.fetch","doc":"This task will fetch the puzzle into `priv/inputs`.\n\nIt will not overwrite an existing input file.","ref":"Mix.Tasks.Aoc.Fetch.html"},{"type":"task","title":"Usage - mix aoc.fetch","doc":"```shell\nmix aoc.fetch [options]\n```","ref":"Mix.Tasks.Aoc.Fetch.html#module-usage"},{"type":"task","title":"Options - mix aoc.fetch","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Fetch.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Fetch.run/1","doc":"","ref":"Mix.Tasks.Aoc.Fetch.html#run/1"},{"type":"task","title":"mix aoc.open","doc":"Opens the puzzle page with your defined browser on on adventofcode.com.\n\nThe command to call with the URL will be defined in the following order:\n\n* Using the `AOC_BROWSER` environment variable.\n* Using the `BROWSER` environment variable.\n* Fallback to `xdg-open`.","ref":"Mix.Tasks.Aoc.Open.html"},{"type":"task","title":"Usage - mix aoc.open","doc":"```shell\nmix aoc.open [options]\n```","ref":"Mix.Tasks.Aoc.Open.html#module-usage"},{"type":"task","title":"Options - mix aoc.open","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Open.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Open.browser/0","doc":"","ref":"Mix.Tasks.Aoc.Open.html#browser/0"},{"type":"function","title":"Mix.Tasks.Aoc.Open.run/1","doc":"","ref":"Mix.Tasks.Aoc.Open.html#run/1"},{"type":"task","title":"mix aoc.run","doc":"Runs your solution with the corresponding year/day input from `priv/inputs`.","ref":"Mix.Tasks.Aoc.Run.html"},{"type":"task","title":"Usage - mix aoc.run","doc":"```shell\nmix aoc.run [options]\n```","ref":"Mix.Tasks.Aoc.Run.html#module-usage"},{"type":"task","title":"Options - mix aoc.run","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `-p, --part  ` - Part of the puzzle. Defaults to both parts.\n* `-b, --benchmark` - Runs the solution repeatedly for 5 seconds to print statistics about execution time. Defaults to `false`.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Run.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Run.run/1","doc":"","ref":"Mix.Tasks.Aoc.Run.html#run/1"},{"type":"task","title":"mix aoc.set","doc":"This task allows to configure the default values used by the other commands.\n\nCustom default values are stored in `.aoc.defaults` at the root of your\nproject.\n\nThis is useful when working on a puzzle belonging to another year, or when\nsolvig the day 20 puzzle takes a long time and you want to continue to work on\nit during day 21, 22, etc.\n\nBy calling `mix aoc.set -d 20`, the other commands such as `mix aoc.run` will\nuse `20` as the default day, unless the flag is explicitly given as in `mix\naoc.run -d 20`.\n\nThe command will accumulate values when called multiple times. For instance:\n\n```shell\nmix aoc.set -d 20\nmix aoc.set -y 2020\n```\n\nExecuting the two commands above will lead to defaults of day 20 and year\n2020.\n\nThen, calling the command with the `-r` flag will reset other unspecified\nflags:\n\n```shell\nmix aoc.set -r -d 22\n```\n\nAfter the command above is executed, the default day will be 22 but the\ndefault year has been reset to be dynamically defined using today's date when\nother commands are called.\n\nFinally, you can reset everything using `mix aoc.set -r`. Deleting the\n`.aoc.defaults` file is another way to do that.","ref":"Mix.Tasks.Aoc.Set.html"},{"type":"task","title":"Usage - mix aoc.set","doc":"```shell\nmix aoc.set [options]\n```","ref":"Mix.Tasks.Aoc.Set.html#module-usage"},{"type":"task","title":"Options - mix aoc.set","doc":"* `-y, --year  ` - Year to use as default.\n* `-d, --day  ` - Day to force as default.\n* `-r, --reset` - Resets the default values. Can be combined with other flags to reset unspecified flags only.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Set.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Set.run/1","doc":"","ref":"Mix.Tasks.Aoc.Set.html#run/1"},{"type":"task","title":"mix aoc.test","doc":"Runs your test file for the Advent of Code puzzle.\n\nNote that test files generated by the `mix aoc.create` command are regular\nExUnit tests.\n\nYou can always run `mix test` or a test specified by a file and an optional\nline number like this:\n\n```shell\nmix test test/2023/day01_test.exs:123\n```\n\nIn order to use this command, you should define it as a test environment\ncommand in your `mix.exs` file by defining a `cli/0` function:\n\n```elixir\ndef cli do\n  [\n    preferred_envs: [\"aoc.test\": :test]\n  ]\nend\n```","ref":"Mix.Tasks.Aoc.Test.html"},{"type":"task","title":"Usage - mix aoc.test","doc":"```shell\nmix aoc.test [options]\n```","ref":"Mix.Tasks.Aoc.Test.html#module-usage"},{"type":"task","title":"Options - mix aoc.test","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--trace` - forward option to `mix test`.\n* `--stale` - forward option to `mix test`.\n* `--failed` - forward option to `mix test`.\n* `--seed  ` - forward option to `mix test`.\n* `--max-failures  ` - forward option to `mix test`.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Test.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Test.run/1","doc":"","ref":"Mix.Tasks.Aoc.Test.html#run/1"},{"type":"task","title":"mix aoc.url","doc":"Outputs the on adventofcode.com URL for a puzzle.\n\nUseful to use in custom shell commands.\n\nNote that due to Elixir compilation outputs you may need to grep for the URL.\nFor instance:\n\n```shell\nxdg-open $(mix aoc.url | grep 'https')\n```","ref":"Mix.Tasks.Aoc.Url.html"},{"type":"task","title":"Usage - mix aoc.url","doc":"```shell\nmix aoc.url [options]\n```","ref":"Mix.Tasks.Aoc.Url.html#module-usage"},{"type":"task","title":"Options - mix aoc.url","doc":"* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Aoc.Url.html#module-options"},{"type":"function","title":"Mix.Tasks.Aoc.Url.run/1","doc":"","ref":"Mix.Tasks.Aoc.Url.html#run/1"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2023 Ludovic Demblans\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Advent Of Code\n\n\n\nThis is a small collection of command line tools to help with [Advent of\nCode](https://adventofcode.com/) by managing inputs, tests and boilerplate code\nwhile you focus on problem solving!\n\n- [Quickstart Guide](#quickstart-guide)\n  - [Install the library](#install-the-library)\n  - [Configuration](#configuration)\n  - [Install your cookie](#install-your-cookie)\n  - [Are you trying this library before December 1st ?](#are-you-trying-this-library-before-december-1st-)\n  - [Let's write some code!](#lets-write-some-code)\n  - [Call your solution module manually](#call-your-solution-module-manually)\n  - [TL; DR](#tl-dr)\n- [Available Commands](#available-commands)\n  - [mix.aoc.open](#mixaocopen)\n  - [mix.aoc.create](#mixaoccreate)\n  - [mix.aoc.test](#mixaoctest)\n  - [mix.aoc.run](#mixaocrun)\n  - [mix.aoc.fetch](#mixaocfetch)\n  - [mix.aoc.url](#mixaocurl)\n  - [Custom default values for commands](#custom-default-values-for-commands)\n- [Upgrading to `0.12`](#upgrading-to-012)","ref":"readme.html"},{"type":"extras","title":"Quickstart Guide - Overview","doc":"Follow these steps to get started on your first AoC puzzle today!\n\nIn a Hurry? Just go to the \"TL; DR\" section.","ref":"readme.html#quickstart-guide"},{"type":"extras","title":"Install the library - Overview","doc":"This framework is distributed as a library as it consists mostly of mix tasks.\nYou may add the dependency to your project, or add it to a new project created\nwith `mix new my_app`.\n\n<!-- block:as_dep -->\n```elixir\ndefp deps do\n  [\n    {:aoc, \"~> 0.13\"},\n  ]\nend\n```\n<!-- endblock:as_dep -->\n\nThen call `mix deps.get` before following the rest of this guide.","ref":"readme.html#install-the-library"},{"type":"extras","title":"Configuration - Overview","doc":"If it does not exist, create a configuration file in your application:\n\n```\nmkdir -p config\ntouch config/config.exs\n```\n\nThen add the configuration for the module prefix. This is the namespace of all\nsolution modules generated by `aoc`. It must start with your app name.\n\n```elixir\n# config/config.exs\n\nimport Config\n\nconfig :aoc,\n  # The prefix is used when creating solutions and test modules with\n  # `mix aoc.create`.\n  prefix: MyApp.Solutions,\n\n  # Optional\n\n  # Include help comments when generating modules and tests.\n  generate_comments: true\n```\n\n**Tip**: The configuration can be defined in `config/runtime.exs` instead.\n\nIn order to run the `aoc.test` command described later in this document, you\nneed to declare that command as a test environment command.\n\nIn your`mix.exs` file, declare the following function:\n\n```elixir\n# mix.exs\ndef cli do\n  [\n    preferred_envs: [\"aoc.test\": :test]\n  ]\nend\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Install your cookie - Overview","doc":"The cookie is used to authenticate with the AoC website. This library will only\nuse it to fetch your inputs and save them locally.\n\nRetrieve your cookie from the AoC website (with you browser developer tools) and\nwrite the session ID in `$HOME/.adventofcode.session`. It should be a long hex\nnumber like `53616c7415146f5f1d5792d97e...`","ref":"readme.html#install-your-cookie"},{"type":"extras","title":"Are you trying this library before December 1st ? - Overview","doc":"The `aoc` commands use dynamic default values: they will always default to the\ncurrent year and day, as they are intended to be used during the event.\n\nIf you want to try this library right now and be ready for day one, why not try a simple puzzle from a previous year?\n\nJust chose a year and a day, for instance 2023 Dec. 1st, and set that as your\nnew default values:\n\n```bash\nmix aoc.set --year 2023 --day 1\n\n# short version\nmix aoc.set -y 2023 -d\n```\n\nThis is also useful if you need to focus on a puzzle for more than one year.\n\nRemember to call `mix aoc.set --reset` when you want to use the dynamic default\nvalues.","ref":"readme.html#are-you-trying-this-library-before-december-1st"},{"type":"extras","title":"Let's write some code! - Overview","doc":"> Note that this guide uses 2023 day 1 for its examples.\n>\n> Also ... this tools gives a strong importance to testing and TDD practice.  If\n> you are playing the race game, it may not be worth it, but you can still use\n> all the file generation part.\n\nAlright, now that you are set up, you can automatically download the input and\ngenerate the files to work on your solution.\n\n#### Generate the files\n\nCall `mix aoc.create` to do just that.\n\nThe generated module will look like that:\n\n```elixir\ndefmodule MyApp.Solutions.Y23.Day01 do\n  alias AoC.Input\n\n  def parse(input, _part) do\n    Input.read!(input)\n  end\n\n  def part_one(problem) do\n    problem\n  end\n\n  # def part_two(problem) do\n  #   problem\n  # end\nend\n```\n\nAlright, I lied, the module is also full of comments to help you understand what\nyou can do in there. See the configuration section to disable those.\n\nThere are three functions in there.\n\n* The `parse/2` function should be focused on transforming the input text into a\n  data structure of your design. Imagine a good model for your data and the\n  algorithms will be simpler to write.\n* The `part_one/1` function receives the output of `parse/2`. It is separated so\n  you can test to call it with made up data, and focus on the problem. Of\n  course, you can just return the input as-is from `parse/2` and do everything\n  in `part_one/2`.\n* Uncomment the `part_two/1` function when you have done part 1.\n\nThere is also a generated test in your `test` directory. Inside, you can find the following test:\n\n```elixir\n  test \"part one example\" do\n    input = ~S\"\"\"\n    This is an\n    example input.\n    replace with\n    an example from\n    the AoC website.\n    \"\"\"\n\n    assert CHANGE_ME == solve(input, :part_one)\n  end\n```\n\nFinally, give a look at your input downloaded in `priv/input/2023/day-01.inp`,\nthis may give you a hint about what to do before writing the tests. Or you can\njust try to solve the example before, your choice!\n\n#### Solve the example\n\nIt's time to read the puzzle if you haven't already. You can call `mix aoc.open` as a shortcut.\n\nAfter having carefully read the the puzzle description, copy it's first example\nand paste it in lieu of the current placeholder. The puzzle also gives the\nanswer for that example: `142`. This is what we are going to use for the assertion.\n\nIn the end, we should have this:\n\n```elixir\n  test \"part one example\" do\n    input = ~S\"\"\"\n    1abc2\n    pqr3stu8vwx\n    a1b2c3d4e5f\n    treb7uchet\n    \"\"\"\n\n    assert 142 == solve(input, :part_one)\n  end\n```\n\nYou may then use `mix aoc.test` to test your implementation with that example.\n\nOr you can just call `mix test` or `mix test test/2023/day_01.exs`. After all,\nthis test is nothing special to the `aoc` library, you can do whatever you want\nin there:\n\n* Add more example tests.\n* Customize the `solve/2` function to your liking, maybe with some `dbg()` or\n  `IO.inspect/2` calls.\n* Use your own ExUnit case template.\n\n#### Solve the puzzle\n\nFinally, once your tests seem correct, you can use `mix aoc.run` to run your\nsolution with the actual input. It will print something like that:\n\n```text\nSolution for 2023 day 1\npart_one: 1014171 in 17.16ms\n```\n\nAnd it's time to submit your first answer to the AoC website. Hopefully, it will\nbe right!\n\nWhen you have the right solution, just uncomment the `test \"part two example\"`\nblock in your test, and the `part_two/1` function in your solution module, and you're ready for part two.\n\nHappy coding :)","ref":"readme.html#let-s-write-some-code"},{"type":"extras","title":"Call your solution module manually - Overview","doc":"If you want to call your module directly from custom tests or from a runner of\nyour own, just pass the path of your input and `:part_one | :part_two` to the\n`parse/2` function, and pipe that to the `part_one/1` or `part_two/1` function:\n\n```elixir\nsolution_for_p1 =\n  \"path/to/input/file\"\n  |> MyApp.Y23.Day1.parse(:part_one)\n  |> MyApp.Y23.Day1.part_one()\n```","ref":"readme.html#call-your-solution-module-manually"},{"type":"extras","title":"TL; DR - Overview","doc":"1. **Installation**: Add the dependency and fetch it.\n   ```elixir\n   # mix.exs\n   defp deps do\n     [\n       {:aoc, \"~> 0.11\"},\n     ]\n   end\n\n   def cli do\n     [\n       preferred_envs: [\"aoc.test\": :test]\n     ]\n   end\n\n   # Run in terminal\n   mix deps.get\n   ```\n\n2. **Configuration**: Set up your configuration and environment.\n   ```elixir\n   # config/config.exs\n   import Config\n   config :aoc, prefix: MyApp.Solutions\n   ```\n\n3. **Authentication**: Save your AoC session cookie value in\n   `$HOME/.adventofcode.session`.\n\n4. **Before the event**: Set default values for previous days.\n   ```bash\n   # Force defaults to 2023 day 1\n   mix aoc.set -y 2023 -d 1\n   # Reset on December 1st\n   mix aoc.set --reset\n   ```\n\n5. **Generate the files**:\n   ```elixir\n   # Generate solution files\n   mix aoc.create\n   ```\n\n6. **Import the example**:\n   ```elixir\n   # Copy input and expected result from the example in\n   # the generated test.\n   test \"part one example\" do\n     input = ~S\"\"\"\n     1abc2\n     pqr3stu8vwx\n     a1b2c3d4e5f\n     treb7uchet\n     \"\"\"\n\n     assert 142 == solve(input, :part_one)\n   end\n   ```\n\n7. **Implement** `parse/2` and `part_one/1` in your module. Use the tests to verify with the example:\n\n   ```bash\n   # Run tests\n   mix aoc.test\n   # Or\n   mix test\n   ```\n\n8. **Run your solution**:\n   ```bash\n   # Run the solution\n   mix aoc.run\n   ```\n\n9. **Manual Execution**: Directly call solution functions if needed.\n   ```elixir\n   # Manual call\n   solution_for_p1 =\n     \"path/to/input/file\"\n     |> MyApp.Solutions.Y23.Day1.parse(:part_one)\n     |> MyApp.Solutions.Y23.Day1.part_one()\n   ```","ref":"readme.html#tl-dr"},{"type":"extras","title":"Available Commands - Overview","doc":"The following commands will use default `year` and `day` based on the current\ndate.\n\nIt is possible to override the defaults with the `mix aoc.set` command, or\nprovide the `--year` and `--day` options to any of them.\n\nThe following docs are generated from the tasks modules documentation. You can\nget any of them using `mix help  `, for instance `mix help aoc.create`.\n\nYou may also get a quick summary of options by calling those commands with the\n`--help` flag, as in `mix aoc.create --help`.\n\n---\n\n\n<!-- block:mix.aoc.open -->","ref":"readme.html#available-commands"},{"type":"extras","title":"mix.aoc.open - Overview","doc":"Opens the puzzle page with your defined browser on on adventofcode.com.\n\nThe command to call with the URL will be defined in the following order:\n\n* Using the `AOC_BROWSER` environment variable.\n* Using the `BROWSER` environment variable.\n* Fallback to `xdg-open`.\n\n#### Usage\n\n```shell\nmix aoc.open [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.open -->\n\n---\n\n\n<!-- block:mix.aoc.create -->","ref":"readme.html#mix-aoc-open"},{"type":"extras","title":"mix.aoc.create - Overview","doc":"This task will execute the following operations:\n\n* Download the input from Advent of Code website into the `priv/inputs`\n  directory.\n* Create the solution module.\n* Create a test module.\n\nExisting files will not be overwritten. It is safe to call the command again\nif you need to regenerate a deleted file.\n\nThe generated files will contain some comment blocks to help you get\naccustomed to using this library. This can be annoying after some time. You\nmay disable generating those comments by setting the appropriate configuration\noption:\n\n    config :aoc, generate_comments: false\n\n#### Usage\n\n```shell\nmix aoc.create [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.create -->\n\n---\n\n\n<!-- block:mix.aoc.test -->","ref":"readme.html#mix-aoc-create"},{"type":"extras","title":"mix.aoc.test - Overview","doc":"Runs your test file for the Advent of Code puzzle.\n\nNote that test files generated by the `mix aoc.create` command are regular\nExUnit tests.\n\nYou can always run `mix test` or a test specified by a file and an optional\nline number like this:\n\n```shell\nmix test test/2023/day01_test.exs:123\n```\n\nIn order to use this command, you should define it as a test environment\ncommand in your `mix.exs` file by defining a `cli/0` function:\n\n```elixir\ndef cli do\n  [\n    preferred_envs: [\"aoc.test\": :test]\n  ]\nend\n```\n\n#### Usage\n\n```shell\nmix aoc.test [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--trace` - forward option to `mix test`.\n* `--stale` - forward option to `mix test`.\n* `--failed` - forward option to `mix test`.\n* `--seed  ` - forward option to `mix test`.\n* `--max-failures  ` - forward option to `mix test`.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.test -->\n\n---\n\n\n<!-- block:mix.aoc.run -->","ref":"readme.html#mix-aoc-test"},{"type":"extras","title":"mix.aoc.run - Overview","doc":"Runs your solution with the corresponding year/day input from `priv/inputs`.\n\n#### Usage\n\n```shell\nmix aoc.run [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `-p, --part  ` - Part of the puzzle. Defaults to both parts.\n* `-b, --benchmark` - Runs the solution repeatedly for 5 seconds to print statistics about execution time. Defaults to `false`.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.run -->\n\n---\n\n\n<!-- block:mix.aoc.fetch -->","ref":"readme.html#mix-aoc-run"},{"type":"extras","title":"mix.aoc.fetch - Overview","doc":"This task will fetch the puzzle into `priv/inputs`.\n\nIt will not overwrite an existing input file.\n\n#### Usage\n\n```shell\nmix aoc.fetch [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.fetch -->\n\n---\n\n\n<!-- block:mix.aoc.url -->","ref":"readme.html#mix-aoc-fetch"},{"type":"extras","title":"mix.aoc.url - Overview","doc":"Outputs the on adventofcode.com URL for a puzzle.\n\nUseful to use in custom shell commands.\n\nNote that due to Elixir compilation outputs you may need to grep for the URL.\nFor instance:\n\n```shell\nxdg-open $(mix aoc.url | grep 'https')\n```\n\n#### Usage\n\n```shell\nmix aoc.url [options]\n```\n\n#### Options\n\n* `-y, --year  ` - Year of the puzzle. Defaults to today's year or custom default.\n* `-d, --day  ` - Day of the puzzle. Defaults to today's day or custom default.\n* `--help` - Displays this help.\n\n\n<!-- endblock:mix.aoc.url -->\n\n---","ref":"readme.html#mix-aoc-url"},{"type":"extras","title":"Custom default values for commands - Overview","doc":"The `mix aoc.set` command allows to set the default year and day. Those values\nare used by default when other commands are not called with `--year` or `--day`\noptions.\n\nThis is useful when working on a problem from a previous year, or when you\nfinish the last days after December 25th, so your CLI history or bash scripts\ncan just call `mix aoc.test` or `mix aoc.run` without options.\n\n* `mix aoc.set --year 2022` – Set the default year to 2022.\n* `mix aoc.set --day 12` – Set the default day.\n* `mix aoc.set --year 2022 --day 12` – Set both defaults.\n* `mix aoc.set --reset --day 12` – Set the default day and delete other default values.\n* `mix aoc.set --reset` – Delete every default values.","ref":"readme.html#custom-default-values-for-commands"},{"type":"extras","title":"Upgrading to `0.12` - Overview","doc":"If you have been using this library in the past, there have been quite some\nchanges in the way the generated files are located.\n\nYou will need to rename your modules for days 1 to 9 with a leading `0`, for instance day 1:\n\n```\nfind lib  -type f -exec sed -i -e 's/.Day1\\b/.Day01\\b/' {} \\;\nfind test -type f -exec sed -i -e 's/.Day1\\b/.Day01\\b/' {} \\;\nfind test -type f -exec sed -i 's/.Day1Test/.Day01Test/' {} \\;\n```\n\nDo this for all 9 days, then call `mix deps.get` and `mix mod.relocate -i` to\nmove your old modules.\n\nSorry for the inconvenience. That change was necessary to have a clean ordering\nof files in the solutions directories and to allow everyone to generate the\nmodules in a directory according to their prefix.","ref":"readme.html#upgrading-to-0-12"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}